/**
 * @file FootyLine.cpp
 * @brief CFootyLine̎s܂B
 * @author Shinji Watanabe
 * @date Oct.30.2008
 */

#include "FootyLine.h"

#define USERFUNC_BUFFERSIZE 512// [U[`߁E֐obt@̃TCY()

//-----------------------------------------------------------------------------
/**
 * @brief RXgN^łBŏ̍s\z܂B
 */
CFootyLine::CFootyLine()
{
	m_nEthicLine = 1;
	m_nLineOffset = 0;
	m_nRealLineNum = 0;
	m_bEmphasisChached = false;
	m_nLineIcons = 0;
}

//-----------------------------------------------------------------------------
/**
 * @brief O̍s̃ItZbglƗϗsɂ̃ItZbglݒ肵܂B
 * @param pPrevLine O̍sւ̃Ce[^
 * @return OƕςĂtrueԂ
 */
bool CFootyLine::SetPrevLineInfo(LinePt pPrevLine)
{
	// obNAbv
	size_t nOffsetBefore = m_nLineOffset;
	size_t nRealBefore = m_nRealLineNum;

	// sԍf[^vZ
	m_nLineOffset = pPrevLine->m_nLineOffset + pPrevLine->m_nEthicLine;
	m_nRealLineNum = pPrevLine->m_nRealLineNum + 1;

	// Ôƈꏏǂ`FbN
	return  m_nLineOffset != nOffsetBefore || m_nRealLineNum != nRealBefore;
}

//-----------------------------------------------------------------------------
/**
 * @brief s̃f[^tbVĊevZs܂B
 * @param nTabLen ^u
 * @param nColumn ܂Ԃ
 * @param nMode ܂Ԃ[h
 * @return _sύXꂽꍇtrueԂ
 * @note f[^ύXŌɂ̏ĂяoKv܂B
 */
bool CFootyLine::FlushString(int m_nFootyID, size_t nTabLen,size_t nColumn,int nMode, bool *NeedRedrawAll, bool ForceListUpdate/*s܂ނ by Tetr@pod*/)
{
	// 錾
	CUrlInfo stInsert;

	// _s̏XV
	size_t nBeforeEthicLine = m_nEthicLine;
	m_nEthicLine = CalcEthicLine(GetLineLength(),nColumn,nTabLen,nMode).m_nEthicLine + 1;

	if (!DrawAllUserFuncs) {// ړI̓[U[`߁E֐Ȃ̂
		// NbJuURĽ
		stInsert.m_nEndPos = -1;
		m_vecUrlInfo.clear();
		forever{
			if (!FindURL(stInsert.m_nEndPos + 1,
				&stInsert.m_nStartPos,&stInsert.m_nEndPos))break;
			m_vecUrlInfo.push_back(stInsert);
		}

		// NbJu[AhX̌
		stInsert.m_nEndPos = -1;
		m_vecMailInfo.clear();
		forever{
			if (!FindMail(stInsert.m_nEndPos + 1,
				&stInsert.m_nStartPos,&stInsert.m_nEndPos))break;
			m_vecMailInfo.push_back(stInsert);
		}

		// NbJux̌ by Tetr@pod
		stInsert.m_nEndPos = -1;
		m_vecLabelInfo.clear();
		if (UseClickableLabel) {
			FOOTY2_PRINTF(L"NbJux̌\n");
			forever{
				if (!FindLabel(stInsert.m_nEndPos + 1,
					&stInsert.m_nStartPos,&stInsert.m_nEndPos))break;
				m_vecLabelInfo.push_back(stInsert);
			}
		}
	}

	// [U[`߁E֐̌(NbJu) by Tetr@pod
	// łĂ̂́AFooty2AddEmphasisR[ĥyŏxB
	// (Footy2AddEmphasisƁA߁E֐ύXꂽ̏ʓ|A߁E֐Ƃʓ|)
	// ƁAvBꂩāBB
	stInsert.m_nEndPos = -1;

	m_vecFuncInfo.clear();// Ƃ肠S폜AȂĂłׂ
	if (UseSearchFunction && ( IsUFUpdateTiming || DrawAllUserFuncs )) {
		// ɏsȂ(̂)
		if (!DrawAllUserFuncs) {
			IsUFUpdateTiming = false;
		}

		FOOTY2_PRINTF(L"[U[`߁E֐̌\n");
		
		int len;

		len = Footy2GetTextLengthW(m_nFootyID, LM_CRLF);
		if(len > 5){// "#REG "
			// ǉꂽȂ񂾂肵AɒǉB
			// #define͍Ōɂ邱ƁA#definȅĂ̂ł
			static const wchar_t * func_define_pp[] = {
				L"deffunc", L"defcfunc",
				L"modinit", L"modterm",
				L"modfunc", L"modcfunc",
				L"func", L"cfunc",
				L"cmd",
				L"comfunc",
				L"define",
			};
			static const int colorkind[] = {// F̎(ݒEBhẼACeXgƑΉĂ܂)
				0, 0, 
				1, 1, 
				2, 2, 
				3, 3, 
				4, 
				5, 
				6, 
				7, // #define ctype
			};

			bool PreprocessorFound = false;// LbĝsɃvvZbT
			// LbĝsɃvvZbTA
			// ߁E֐ނςĂ邾낤ƌ߂āA
			// ߁E֐̃XgXV
			// ƍXVꂽmFƁA2{炢̎ԂH

			if (!DrawAllUserFuncs) {
				if (defined_funclist && !ForceListUpdate) {// `ς݂ŋXgXVtOĂȂȂ
					size_t CaretLine = 0;
					if (Footy2GetCaretPosition(m_nFootyID, &CaretLine, NULL) == FOOTY2ERR_NONE) {
						wchar_t *CaretLineData = (wchar_t *)Footy2GetLineW(m_nFootyID, CaretLine);
						if (CaretLineData != NULL) {
							const wchar_t *PreprocessorPosition = wcschr(CaretLineData, L'#');
							if (PreprocessorPosition != NULL) {
								for (; L'\t' == *PreprocessorPosition || L' ' == *PreprocessorPosition; PreprocessorPosition++);// 󔒂ǂݔ΂
								for(int i = 0; i < sizeof(func_define_pp)/sizeof(func_define_pp[0]); i++) {
									if (wcslen(PreprocessorPosition) > wcslen(func_define_pp[i])) {
										if (wcscmp(PreprocessorPosition, func_define_pp[i])) {
											PreprocessorFound = true;// I
											break;
										}
									}
								}
							}
						}
					}
				}
				else {// 񂩋XgXVtOĂȂ
					PreprocessorFound = true;// ăXg쐬
				}

				if (PreprocessorFound) {// 疽߁E֐XgXV
					// ߁E֐T
					FOOTY2_PRINTF(L"߁E֐̃XgAbv\n");
					// X̖߁E֐Xg
					if (defined_funclist) {// `ς݂Ȃ
						defined_funclist = false;// Ƃ肠tO낵

						// 
						free(funclist);
						free(kindlist);
					}

					// XgAbv
					// 錾
					wchar_t lname[USERFUNC_BUFFERSIZE];
					wchar_t *buffer;
					wchar_t *wp;
					// wchar_t *funclist;// O[o(̂)
					// int *kindlist;// O[o(̂)
					int line;

					funcnum = 0;

					buffer = (wchar_t *) calloc( len + 2 /* I[Ɣԕ */, sizeof(wchar_t) );
					Footy2GetTextW(m_nFootyID, buffer, LM_CRLF, len + 1);

					for (int getmode=0; getmode<2; getmode++) {
						int nowindex = 0;
						line = 1;
						wp = buffer;
						for (; *wp; line++, wp++) {
							// 1sǂݍ
							for(; *wp && 0x0d != *wp; wp++) {
								// 擪̋󔒂𖳎
								if( L' ' == *wp || L'\t' == *wp ) {
									continue;
								}
								// vvZbTǂݔ΂
								if( L'#' == *wp ) {
									int namelen = 0;
									do {
										for(wp++; *wp && 0x0d != *wp ; wp++) {
											if( (0 < namelen || (L' ' != *wp && L'\t' != *wp)) &&
												(L'\\' != *wp || (0x0a != wp[1] && 0x0d != wp[1])) &&
												0x0a != *wp && 0x0d != *wp &&
												namelen < sizeof(lname)/sizeof(lname[0]) - 1 ) {
												lname[namelen++] = *wp;
											}
										}
										line++;
									} while ( L'\\' == *(wp - 1) && *wp );
									line--;
									lname[namelen] = L'\0';
									//
									for(int i = 0; i < sizeof(func_define_pp)/sizeof(func_define_pp[0]); i++) {
										if (DontColor_func && ( i == 6 || i == 7 || i == 8 ))// #funcA#cfuncA#cmd FȂ
											continue;
										if (DontColor_define && i == 10)// #defineA#define ctype FȂ
											continue;

										int comp_len = min((int)wcslen(func_define_pp[i]), namelen);
										if( !wcsncmp(lname, func_define_pp[i], comp_len) ) {
											wchar_t *pa, *pb;
											pb = lname + comp_len;
											int kind = i;
											do {
												pa = pb;
												for(; L'\t' == *pa || L' ' == *pa; pa++, pb++);	// '#'̒̋󔒂XLbv
												for(; L'\t' != *pb && L' ' != *pb && L',' != *pb && *pb; pb++);	// 󔒂܂ł擾
												namelen = (int)(pb - pa);
												if( sizeof(lname) <= (int)(pa - lname) + namelen ) { DebugBreak(); }
												wcsncpy(lname, pa, namelen);
												/*memcpy(lname, pa, namelen * sizeof(wchar_t));*/
												lname[namelen] = L'\0';
												
												if (i == 10 && _wcsicmp(lname, L"ctype") == 0 ) {// #define ctypeȂ
													kind = 11;
												}
											} while( !_wcsicmp(lname, L"local") && _wcsicmp(lname, L"global") && _wcsicmp(lname, L"ctype") );
											//
											if( *lname ) {
												// reallocgpȂ悤ɂ邽߂ȂĂ܂
												// ̗]n̂ŁANCā
												if (getmode == 0) {// ŏ̓JEgAbv
													funcnum++;
												}
												else {// ڂ͎ۂɎ擾
													wcscpy(funclist + nowindex * USERFUNC_BUFFERSIZE, lname);
													kindlist[nowindex] = kind;
													nowindex++;
												}
											}
											break;
										}
									}
									break;
								}
								// Rgǂݔ΂
								if( L';' == *wp || (L'/' == *wp && L'/' == wp[1]) ) {// ;܂//ł͂܂Rg
									// s܂œǂݔ΂
									for(wp++; *wp && 0x0d != *wp ; wp++);
									break;
								}
								if( L'/' == *wp && L'*' == wp[1] ) {//  / *ł͂܂Rg
									for(wp++; *wp ; wp++) {
										if( L'*' == *wp && L'/' == wp[1] ) {
											wp++;
											break;
										}
										if( 0x0d == *wp ) {
											line++;
										}
									}
									continue;
								}
								// ̃Xe[gg܂œǂݔ΂
								for(bool bEscape = false;
									*wp && 0x0d != *wp && L':' != *wp &&
									L';' != *wp && (L'/' != *wp || L'*' != wp[1]) && (L'/' != *wp || L'/' != wp[1]); wp++)
								{
									if( L'\"' == *wp && !bEscape ) {
										bool bDameChk = false;
										// ǂݔ΂
										if( L'{' == *(wp - 1) ) { // s
											wp += 2;
											for(bool bEscape = false; *wp && (L'\"' != *wp || L'}' != wp[1] || bEscape); ) {
												if( L'\\' == *wp ) {
													bEscape = !bEscape;
												}
												wp++;
											}
										} else {
											wp++;
											for(bool bEscape = false; *wp && (L'\"' != *wp || bEscape) && 0x0d != *wp; ) {
												if( L'\\' == *wp ) {
													bEscape = !bEscape;
												}
												wp++;
											}
										}
										wp--;
										continue;
									}
								}
								if( 0x0d == *wp ) {
									break;
								}
								if( L':' != *wp ) {
									wp--;
								}
							}
							if( 0x0d == *wp && 0x0a == wp[1] ) {
								wp++;
							}
						}// ʂ̊Oc for (; *wp; line++, wp++)
						if (funcnum < 1) {
							break;
						}
						if (getmode == 0) {
							// m
							funclist = (wchar_t *)malloc(funcnum * sizeof(lname) + 4);
							kindlist = (int *)malloc(funcnum * sizeof(int));

							// sĂȂmF
							if (funclist == NULL || kindlist == NULL) {// ǂ炩s
								if (funclist != NULL) {
									free(funclist);
									funclist = NULL;
								}
								if (kindlist != NULL) {// Ə
									free(kindlist);
									kindlist = NULL;
								}

								funcnum = 0;// 邱ƂŁȀɐi܂Ȃ
								break;
							}

							defined_funclist = true;// mۂ̂ŃtO𗧂Ă

							// ϗvȂ
							/*// 0tB
							memset(funclist, 0, sizeof(funclist));
							memset(kindlist, 0, sizeof(kindlist));*/
						}
					}// ʂ̊Oc for (int getmode=0; getmode<2; getmode++)

					// gȂ̂ŉ
					free(buffer);


					if (funcnum > 0) {// ߁E֐
						// ēo^
						// S폜͂łɂĂ̂ŏȂOK
						DrawAllUserFuncs = true;// tO𗧂Ă
						// ׂĂ̍s
						for (LinePt Line = GetFooty(m_nFootyID)->m_cDoc.GetTopLine(); Line != GetFooty(m_nFootyID)->m_cDoc.GetLastLine(); Line++) {
							GetFooty(m_nFootyID)->m_cDoc.SetLineInfo2(Line);// o^
							// Line->GetEthicLine();// ȂĂ݂
						}
						DrawAllUserFuncs = false;// ătO낷

						// Sčĕ`̃tO𗧂ĂĂ
						*NeedRedrawAll = true;
					}
				}// ʂ̊Oc if (PreprocessorFound)
			}// ʂ̊Oc if (DrawAllUserFuncs)

			if (!PreprocessorFound && funcnum > 0) {// DrawAllUserFuncs̃tOŜ͖̂Ə
				FOOTY2_PRINTF(L"߁E֐̌Eo^\n");
				for (int i=0; i<funcnum; i++) {
					stInsert.m_nEndPos = -1;
					forever{
						bool bIsFunction = ( kindlist[i] % 2 == 1 && kindlist[i] %3 > 0 );
						if (!FindFunc(stInsert.m_nEndPos + 1,
							&stInsert.m_nStartPos, &stInsert.m_nEndPos, funclist + i * USERFUNC_BUFFERSIZE, bIsFunction, CustomMatchCase))break;
						stInsert.m_nKind = colorkind[kindlist[i]];
						m_vecFuncInfo.push_back(stInsert);
					}
				}
			}
		}// ʂ̊Oc if (len > 5)
		else {
			funcnum = 0;
		}

		if (!DrawAllUserFuncs) {
			IsUFUpdateTiming = true;// ȊÔƂ͏OK
		}
	}// ʂ̊Oc if (UseSearchFunction && ( IsUFUpdateTiming || DrawAllUserFuncs ))

	return m_nEthicLine != nBeforeEthicLine;
}


//-----------------------------------------------------------------------------
/**
 * @brief nPos̈ʒuǂӂɂ邩vZ郋[`łB
 */
CFootyLine::EthicInfo CFootyLine::CalcEthicLine(size_t nPos,size_t nColumn,size_t nTab,int nMode) const
{
	// 錾
	const wchar_t *pWork = GetLineData();
	EthicInfo stRet;
	// 
	stRet.m_nEthicLine = 0;
	stRet.m_nEthicColumn = 0;
	// 񑖍
	for (size_t i=0;i<nPos;i++,pWork++)
	{
		// ^u
		if (*pWork == L'\t')
		{
			for (stRet.m_nEthicColumn++;;stRet.m_nEthicColumn++)
			{
				if (stRet.m_nEthicColumn % nTab == 0)break;
			}
		}
		else
		{
			// {ǂ肷
			bool bIsDualWidth = false;
			if (IsSurrogateLead(*pWork))	// TQ[gyÂPoCg
			{
				bIsDualWidth = IsDualChar(*pWork,*(pWork+1));
				pWork++;i++;
			}
			else							// TQ[gyAł͂ȂƂ
			{
				bIsDualWidth = IsDualChar(*pWork);
			}
			// ʒu炷
			if (bIsDualWidth)stRet.m_nEthicColumn += 2;
			else stRet.m_nEthicColumn ++;
		}
		// ̕֍s܂H
		if (IsGoNext(pWork,i,stRet.m_nEthicColumn,nColumn,nMode))
		{
			stRet.m_nEthicColumn = 0;
			stRet.m_nEthicLine ++ ;
		}
	}
	// lԂ
	return stRet;
}

//-----------------------------------------------------------------------------
/**
 * @brief ϗsۂ̌vZ郋[`łB
 * @note nEthicLinenEthicPos0x[Xœn܂B
 */
size_t CFootyLine::CalcRealPosition(size_t nEthicLine,size_t nEthicPos, size_t nColumn,size_t nTab,int nMode) const
{
	// 錾
	const wchar_t *pWork = GetLineData();
	size_t nLineLength = GetLineLength();
	size_t nVisPosition = 0;
	size_t nNowEthic = 0;
	size_t i;
	// 񑖍
	for (i=0;i<nLineLength;i++,pWork++)
	{
		// K邩(IH)
		if (nNowEthic == nEthicLine)
		{
			if (nVisPosition >= nEthicPos)break;
		}
		// ^u
		if (*pWork == L'\t')
		{
			for (nVisPosition++;;nVisPosition++)
			{
				if (nVisPosition % nTab == 0)break;
			}
		}
		else
		{
			// {ǂ肷
			bool bIsDualWidth = false;
			if (IsSurrogateLead(*pWork))	// TQ[gyÂPoCg
			{
				bIsDualWidth = IsDualChar(*pWork,*(pWork+1));
				pWork++;i++;
			}
			else							// TQ[gyAł͂ȂƂ
			{
				bIsDualWidth = IsDualChar(*pWork);
			}
			// ʒu炷
			if (bIsDualWidth)nVisPosition += 2;
			else nVisPosition ++;
		}
		// ̍s֍s܂H
		if (IsGoNext(pWork,i,nVisPosition,nColumn,nMode))
		{
			nVisPosition = 0;
			nNowEthic ++ ;
		}
	}
	// lԂ
	return i;
}

//-----------------------------------------------------------------------------
/**
 * @brief s̍ŏw肳ꂽʒu܂ł̋󔒐vZ
 * @param	nPos	[in] vZʒu
 * @return 
 */
size_t CFootyLine::CalcAutoIndentPos( size_t nPos ) const
{
	size_t i = 0;
	for ( i = 0; i < nPos; i++ )
	{
		wchar_t c = m_strLineData[ i ];
		if ( c != '\t' && c != ' ' )
		{
			break;
		}
	}
	return i;
}

/*[EOF]*/
