/*===================================================================
CFootyViewNX
Footỹr[Ǘs܂B
̃t@C̓bZ[WǗs܂B
===================================================================*/

#include "FootyView.h"

/*-------------------------------------------------------------------
CFootyView::MainProc
CvV[W
-------------------------------------------------------------------*/
LRESULT CFootyView::MainProc(UINT msg,WPARAM wParam,LPARAM lParam){
	/*zC[bZ[Wǂ擾*/
#ifndef UNDER_CE
	if (msg == m_uWheelMsg)msg = WM_MOUSEWHEEL;
#endif	/*UNDER_CE*/

	/*bZ[Wɂꍇ*/
	switch(msg){
//L[֘A
	case WM_CHAR:
		OnChar((wchar_t)wParam);
		break;
	case WM_IME_COMPOSITION:
		OnImeComposition(lParam);
		return DefWindowProc(m_hWnd,msg,wParam,lParam);
	case WM_IME_REQUEST:
		return OnImeRequest(wParam,lParam);
	case WM_KEYDOWN:
		OnKeyDown((int)wParam);
		break;
	case WM_GETDLGCODE:
		if (m_bIsFocused)	/*tH[JXƂ̂ݑS擾*/
			return DLGC_WANTALLKEYS;
		else				/*ȊO̓ftHgɔC*/
			return DefWindowProc(m_hWnd,msg,wParam,lParam);
//}EX֘A
	case WM_LBUTTONDOWN:
		OnMouseDown((int)(short)LOWORD(lParam),(int)(short)HIWORD(lParam));
		break;
	case WM_MOUSEMOVE:
		OnMouseMove((int)(short)LOWORD(lParam),(int)(short)HIWORD(lParam));
		break;
	case WM_LBUTTONUP:
		OnMouseUp((int)(short)LOWORD(lParam),(int)(short)HIWORD(lParam));
		break;
	case WM_LBUTTONDBLCLK:
		OnMouseDouble((int)(short)LOWORD(lParam),(int)(short)HIWORD(lParam));
		break;
	case WM_MOUSEWHEEL:
		OnMouseWheel((short)HIWORD(wParam) < 0);
		break;
//XN[
    case WM_VSCROLL:
		OnVScroll(wParam);
        break;
	case WM_HSCROLL:
		OnHScroll(wParam);
		break;
//^C}[Cxg
	case WM_TIMER:
		switch(wParam)
		{
		case eTimer_AutoVertical:
			FOOTY2_PRINTF( L"On Auto Vertical Scroll Timer\n" );
			OnAutoVerticalTimer();
			break;
		case eTimer_AutoHorizontal:
			FOOTY2_PRINTF( L"On Auto Horizontal Scroll Timer\n" );
			OnAutoHorizontalTimer();
			break;
		}
		break;
//tH[JX֘A
	case WM_SETFOCUS:
		OnGotFocus();
		FOOTY2_PRINTF(L"On got focus\n");
		break;
	case WM_KILLFOCUS:
		OnLostFocus();
		FOOTY2_PRINTF(L"On lost focus\n");
		break;
	case WM_PAINT:
		PAINTSTRUCT ps;
		BeginPaint(m_hWnd,&ps);
		//FOOTY2_PRINTF( L"BeginPaint %d\n", m_nFootyID );
		Refresh(ps.hdc,&ps.rcPaint);
		EndPaint(m_hWnd,&ps);
		//FOOTY2_PRINTF( L"EndPaint %d\n", m_nFootyID );
		break;
	default:
		return DefWindowProc(m_hWnd,msg,wParam,lParam);
	}
	return false;
}

/*----------------------------------------------------------------
CFootyView::OnLostFocus
tH[JXƂɔ܂B
----------------------------------------------------------------*/
void CFootyView::OnLostFocus(){


	m_bIsFocused = false;
	m_cCaret.Hide();		/*Lbg\ɂ*/
	if ((m_bUnderlineDraw == false)){
		m_cCaret.Destroy();		/*jB*/
		CaretRefresh();
	}
	/*Cxgo*/
	if (m_pFuncFocus)
		m_pFuncFocus(m_nFootyID,m_pDataFocus,m_nViewID,false);
	
//	m_cCaret.Hide();		/*Lbg\ɂ*/
//	// 4̃r[tH[JXĂȂƂ͔jȂ
//	// Płr[tH[JXĂꍇ͔j

//	if ( ( m_pView[0].IsFocused() == false ) && ( m_pView[1].IsFocused() == false ) && ( m_pView[2].IsFocused() == false ) && ( m_pView[3].IsFocused() == false ) ){
//		FOOTY2_PRINTF( L"Test_OnLostFocus %d\n", m_nFootyID );
//	}else{
//		if ((m_bUnderlineDraw == false)){
//			m_cCaret.Destroy();		/*jB*/
//			CaretRefresh();
//		}
//	}


//	m_bIsFocused = false;
	
	/*Cxgo*/
//	if (m_pFuncFocus)
//		m_pFuncFocus(m_nFootyID,m_pDataFocus,m_nViewID,false);
	
}

/*----------------------------------------------------------------
CFootyView::OnGotFocus
tH[JX𓾂Ƃɔ܂B
----------------------------------------------------------------*/
void CFootyView::OnGotFocus(){

	// A_[C̕\oO(dlH)C by Tetr@pod
	if (m_bUnderlineDraw){// tH[JX̃A_[C̕`悪LȂƂŁA
		for(int i=0; i<4; i++){// ̃r[
			if (m_pView[i].IsFocused() == false){// tH[JXȂƂ
				m_pView[i].m_cCaret.Destroy();// ̃r[̃A_[Cj
				m_pView[i].CaretRefresh();// čXV
			}
		}
	}

	if (!m_bIsFocused){				/*tH[JXĂƂ*/
		m_bIsFocused = true;		/*tH[JXtO𗧂Ă*/
		Refresh(false);				/*ĕ`悳*/
	}
	CaretMove();
	/*Cxgo*/
	if (m_pFuncFocus)
		m_pFuncFocus(m_nFootyID,m_pDataFocus,m_nViewID,true);
}
